<%@ include file="/common/taglibsT3.jsp" %>
<%@ page contentType="text/html; charset=UTF-8" %>

<SCRIPT language="JavaScript" src="rules/scripts/rules.js"></SCRIPT>
<SCRIPT language="JavaScript" src="rules/scripts/dynamicRows.js"></SCRIPT>
<SCRIPT language="JavaScript" src="rules/scripts/itemPriorityList.js"></SCRIPT>
<SCRIPT language="JavaScript" src="rules/scripts/autoSizing.js"></SCRIPT>
<SCRIPT language="JavaScript" src="common/scripts/calendar.js"></SCRIPT>
<SCRIPT language="JavaScript" src="rules/scripts/sort.js"></SCRIPT>
<SCRIPT language="JavaScript" src="rules/scripts/console.js"></SCRIPT>
<SCRIPT language="JavaScript" src="rules/scripts/consolePage.js"></SCRIPT>
<script language="JavaScript" src="common/scripts/sasSolutions.js"></script>
<script language="JavaScript" src="common/scripts/i18n.js"></script>


<form id="oseConsoleActionForm" name="oseConsoleActionForm"   action='<c:url value="/oseCommand.action"/>'  method="post"  target="oseFrame" >
	<input type="hidden" name="method"    value="oseAction"/>
	<input type="hidden" name="frametype" value="ose"/>
	<input type="hidden" name="query" />
	<input type="hidden" name="oseSelectedServer" />
</form>

<SCRIPT>

   <c:url var="oseURL"  value="/oseCommand.action?frametype=ose"/>
   var oseURL = '${oseURL}';

   var oseServerList= new Array();
   var oldOseList= new Array();
   var agsServerList = new Array();
   var oldAgsList = new Array();

   var checkJOSE = '${isJOSE}';
   var oseresponse;
   var waitIndicator = false;
   var waitAgsIndicator = false;
   var waitOseIndicator = false;
   var waitEtlIndicator = false;
   var sasSpinner = "common/images/spinner.gif";

   var cookieRetentionPeriod = new Date();
   cookieRetentionPeriod.setDate(cookieRetentionPeriod.getDate()+365);

   i18n.init();
   var i18nStrings = {
			   "activeStatus":$i18n("console.console.js.active.txt"),
			   "downStatus":$i18n("console.console.js.down.txt"),
			   "notRespondingStatus":$i18n("console.console.js.notresponding.txt"),
			   "idleStatus":$i18n("console.console.js.idle.txt"),
			   "restartCommand":$i18n("console.console.js.restart.txt"),
			   "startCommand":$i18n("console.console.js.start.txt"),
			   "redeployCommand":$i18n("console.console.js.redeploy.txt"),
			   "stopCommand":$i18n("console.console.js.stop.txt")
			   };
			   
	var osetimeOut=0;

 function startRefresh(){
	   refreshOse();
 }
 
 function refreshOse(){
	   osetimeOut = setTimeout("frames['oseFrame'].location.href='" + oseURL +  "&query=status" + "'", getUpdateMilliseconds(1));
 }

 function stopRefresh(){
	stopOseRefresh();
 }

 function stopOseRefresh(){

   if (osetimeOut && osetimeOut != 0 )
   {
	  clearTimeout(osetimeOut);
	  osetimeOut = 0;
   }
 }

function oseAction(o, action)
{
	stopOseRefresh();
	showOsebusy();

	var oForm = document.getElementById("oseConsoleActionForm");
	oForm.elements["query"].value             = action;
	oForm.elements["oseSelectedServer"].value = o;
	oForm.submit();
}

function startOse(o,s)
{
	if(s == 'Down')
	{
   	   oseAction(o, "startOse");
	}
	else if(s == 'Active' || s == 'Idle')
	{
		if (confirm("Are You Sure?"))
		{
			oseAction(o, "restartOse");
		}
	}
}
function stopOse(o)
{
	if (confirm("Are You Sure?"))
	{
		oseAction(o, "stopOse");
	}
 }

function expand(s)
{
  var td = s;
  var d = td.getElementsByTagName("div").item(0);

  var leftTop = getLeftTop(td);
  var winH;
  var winW;
  if (window.innerHeight)
    winW = parseInt(window.innerWidth);
  else
    winW = parseInt(document.body.offsetWidth) - 4;

  if (winW > leftTop[0] + parseInt(d.style.width) + 34)
    d.style.left = leftTop[0] + 34;
  else
    d.style.left = winW - parseInt(d.style.width);
  d.style.top = leftTop[1] + 8;

  td.className = "menuHover";
  d.className = "menuHover";
}

function collapse(s)
{
  var td = s;
  var d = td.getElementsByTagName("div").item(0);

  td.className = "menuNormal";
  d.className = "menuNormal";
}

function showOsebusy(){
	 var statusArea = document.getElementById( "oseStatusDisplay" );
    if (statusArea && !waitIndicator)
    {
       statusArea.innerHTML = '<image title="Request in progress..." src="' + sasSpinner + '" border="0" height="15" width="15"/>' ;
	 waitIndicator = true;
	 waitOseIndicator = true ;
	}
}

function oseLog(o){
	stopOseRefresh();
	showOsebusy();
	var url= oseURL+"?query=oseLog&oseSelectedServer="+o;
	parent.frames[ "detail" ].location.href = url;

}
</SCRIPT>
<%-- This jsp is used to display the status of all the servers. --%>

<c:choose>
<c:when test="${param.frametype == 'ose'}">

  <%-- The child frame just calls a method in the parent to create a new row --%>
	<SCRIPT language="JavaScript">
		<c:forEach var="s" items="${oseServers}" varStatus="status">
		 oseServerList["${status.count}"]= new Array(6);
		 oseServerList["${status.count}"][0] = "${s.description}";
		 oseServerList["${status.count}"][1] = "${s.status}";
		 var checkIfJOSE = parent.window.checkJOSE;
		 if(checkIfJOSE==true){ 
			 oseServerList["${status.count}"][2] = false;
			 oseServerList["${status.count}"][3] = "${s.stoppable}";
			 oseServerList["${status.count}"][4] = false;
		 }
		 else{
		 	oseServerList["${status.count}"][2] = "${s.startable}";
		 	oseServerList["${status.count}"][3] = "${s.stoppable}";
		 	oseServerList["${status.count}"][4] = "${s.restartable}";
		 }
		 oseServerList["${status.count}"][5] = "${s.serverId}";
	   </c:forEach>
	   oseResponse= '${esapi:encodeForJavaScript(oseResponse)}';
	   parent.window.updateOse(oseServerList,oseResponse,'${esapi:encodeForJavaScript(param.query)}','${esapi:encodeForJavaScript(param.initialLoad)}',i18nStrings,checkIfJOSE);

  </SCRIPT>

</c:when>

<c:otherwise>

 <div id="consoleTabScrollableDiv" class="consoleTabScrollableClass" style="height:100%;">

   <%-- Title --%>
   <table style="width:98%;float:left;" border='0'>
     <tr>
       <td nowrap style="width:100%;">
          <h4><fmt:message key='console.consoleMonitorDetailContent.transactionPipelineStatus.txt'/></h4>
       </td>
	   <td style="text-align:left;">
	   	   <span id="agsStatusDisplay"></span>
		   <span id="oseStatusDisplay"></span>
	   </td>
	   <td align='left' nowrap>
       <fmt:message key='console.consoleMonitorDetailContent.refresh.txt'/>:
       </td>
       <%-- Shorten by the warning period - 120 seconds --%>
       <c:set var="maxRefreshInterval" value="${pageContext.session.maxInactiveInterval - 120}"/>
       <td>
       &nbsp;<select name="updateInterval" id="updateInterval" onchange="setCookie('control_updateInterval',''+this.selectedIndex,cookieRetentionPeriod);startRefresh();">
         <option value="1">1&nbsp;<fmt:message key='console.consoleControlDetailContent.second.txt'/>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</option>
         <option value="2">2&nbsp;<fmt:message key='console.consoleControlDetailContent.seconds.txt'/></option>
         <option value="3">3&nbsp;<fmt:message key='console.consoleControlDetailContent.seconds.txt'/></option>
         <option value="4">4&nbsp;<fmt:message key='console.consoleControlDetailContent.seconds.txt'/></option>
         <option value="5">5&nbsp;<fmt:message key='console.consoleControlDetailContent.seconds.txt'/></option>
         <option value="10">10&nbsp;<fmt:message key='console.consoleControlDetailContent.seconds.txt'/></option>
         <option value="15">15&nbsp;<fmt:message key='console.consoleControlDetailContent.seconds.txt'/></option>
         <option value="20">20&nbsp;<fmt:message key='console.consoleControlDetailContent.seconds.txt'/></option>
         <option value="25">25&nbsp;<fmt:message key='console.consoleControlDetailContent.seconds.txt'/></option>
         <option value="30">30&nbsp;<fmt:message key='console.consoleControlDetailContent.seconds.txt'/></option>
         <option value="60">60&nbsp;<fmt:message key='console.consoleControlDetailContent.seconds.txt'/></option>
         <option value="120">2&nbsp;<fmt:message key='console.consoleControlDetailContent.minutes.txt'/></option>
         <option value="180">3&nbsp;<fmt:message key='console.consoleControlDetailContent.minutes.txt'/></option>
         <option value="240">4&nbsp;<fmt:message key='console.consoleControlDetailContent.minutes.txt'/></option>
         <option value="300">5&nbsp;<fmt:message key='console.consoleControlDetailContent.minutes.txt'/></option>
        <c:if test="${maxRefreshInterval > 600}">
         <option value="600">10&nbsp;<fmt:message key='console.consoleControlDetailContent.minutes.txt'/></option>
        </c:if>
        <c:if test="${maxRefreshInterval > 900}">
         <option value="900">15&nbsp;<fmt:message key='console.consoleControlDetailContent.minutes.txt'/></option>
         </c:if>
        <c:if test="${maxRefreshInterval > 1200}">
         <option value="1200">20&nbsp;<fmt:message key='console.consoleControlDetailContent.minutes.txt'/></option>
         </c:if>
        <c:if test="${maxRefreshInterval > 1500}">
         <option value="1500">25&nbsp;<fmt:message key='console.consoleControlDetailContent.minutes.txt'/></option>
         </c:if>
        <c:if test="${maxRefreshInterval > 1800}">
         <option value="1800">30&nbsp;<fmt:message key='console.consoleControlDetailContent.minutes.txt'/></option>
         </c:if>
        <c:if test="${maxRefreshInterval > 3600}">
         <option value="3600">60&nbsp;<fmt:message key='console.consoleControlDetailContent.minutes.txt'/></option>
        </c:if>
       </select>
      </td>
   </tr>
   </table>
    <br><br>

   <style>
   TD { padding-top:0px;padding-bottom:0px;padding-left:10px;text-align:left; white-space:nowrap; }
   PRE { font-size:10px; margin-bottom:2px;}
   </style>

   <!--- Status display is fixed size -->
   <!--  <div id="statusDiv" style="width:100px; overflow:auto;">-->
   <div id="statusDiv" overflow:auto;">
   <TABLE style="width:99%;border:1px solid #659EC7">
	 <TBODY>
		<TR bgcolor="#e0e2e5" height = "25pt" bordercolor="#ffffff">
	    	<TD width ="50%"><fmt:message key='console.consoleMonitorDetailContent.process.txt'/></TD>
	    	<TD><fmt:message key='console.consoleMonitorDetailContent.status.txt'/></TD>
	    	<TD><fmt:message key='console.consoleMonitorDetailContent.commands.txt'/></TD>
	    </TR>

	    <TR height = "25pt" bordercolor="#ffffff">
	    	<TD id="OseControllerid"><fmt:message key='console.consoleMonitorDetailContent.scoringEngine.txt'/></TD>
	    	<TD id="OseControllerStatus"></TD>
	    	<TD></TD>
	    </TR>

     <c:forEach var="oseServer" items="${oseServers}"  varStatus="status" >

	   <TR height = "16pt" bordercolor="#ffffff">
	    	<TD id="OseServerid_${status.count}">&nbsp;&nbsp;${oseServer.description}</TD>
	    	<TD id="OseServerStatus_${status.count}" style="color:#808080;font-weight:bold;"><fmt:message key='console.consoleControlDetailContent.acquiring.txt'/></TD>

	    	<TD id="OseServerButton_${status.count}">
				<table>
					<TR>
						<c:if test="${isJOSE==true}">
							<c:if test="${oseServer.restartable}">
								<TD id="OseServerStart_${status.count}"><a href="javascript:startOse('${oseServer.serverId}','${oseServer.status}')"><fmt:message key='console.console.js.redeploy.txt'/></a></TD>
							</c:if>
							<c:if test="${!oseServer.restartable}">
								<TD id="OseServerStart_${status.count}" style="color:#999999;"><fmt:message key='console.consoleControlDetailContent.start.txt'/></TD>
							</c:if>
						</c:if>
						<c:if test="${isJOSE==false}">
							<c:if test="${oseServer.startable}">
								<TD id="OseServerStart_${status.count}"><a href="javascript:startOse('${oseServer.serverId}','${oseServer.status}')"><fmt:message key='console.consoleControlDetailContent.start.txt'/></a></TD>
							</c:if>
							<c:if test="${!oseServer.startable}">
								<TD id="OseServerStart_${status.count}" style="color:#999999;"><fmt:message key='console.consoleControlDetailContent.start.txt'/></TD>
							</c:if>
						</c:if>
						<c:if test="${oseServer.stoppable}">
							<TD id="OseServerStop_${status.count}"><a href="javascript:stopOse('${oseServer.serverId}')"><fmt:message key='console.consoleControlDetailContent.stop.txt'/></a></TD>
						</c:if>
						<c:if test="${!oseServer.stoppable}">
							<TD id="OseServerStop_${status.count}" style="color:#999999;"><fmt:message key='console.consoleControlDetailContent.stop.txt'/></TD>
						</c:if>
						<TD style="display:none;" id='OseServerLog_${status.count}' style="color=#999999;"><fmt:message key='console.consoleControlDetailContent.log.txt'/></TD>
						<TD id="OseServerMore_${status.count}"></TD>

					</TR>
				</table>
			</TD>
	    </TR>

		</c:forEach>

		<tr><td colspan="3" style="border:0px;">&nbsp;</td></tr>

	<TR height = "16pt" bordercolor="#ffffff">
	  <TD colspan="3">&nbsp;</TD>
	</TR>
	</TBODY>
   </TABLE>
   </div>

<!-- Title of messages area -->
<table style="width:99%;float:left;" border=0>
     <tr>
       <td nowrap style="width:100%">
          <h4><fmt:message key='console.consoleMonitorDetailContent.messages.txt'/></h4>
       </td>
	  </tr>
</table>

<!-- Messages area resizes to fill screen -->
<table style="width:99%;border:1px solid #659EC7">
   <tr bordercolor="#ffffff">
      <td id="Message" valign='top'>
      <div id="messageDiv" style="overflow:auto; height: auto; width:100%; margin-bottom:1.2rem">
        ${oseResponse}
        <c:if test="${isJOSE==false}">${agsResponse}</c:if>
      </div>
      </td>
   </tr>
</table>

   <iframe id="oseFrame" name="oseFrame" src="${oseURL}&query=status&initialLoad=1"  height='0' width='1' border="0" style="display:none"></iframe>

</div>

  <SCRIPT>
  	var updateInterval = getCookie("control_updateInterval");
  	document.getElementById("updateInterval").selectedIndex = (updateInterval) ? updateInterval : 6;
  </SCRIPT>
	</c:otherwise>
</c:choose>

